unit UnidadConfiguracion;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, inifiles;

type
  TformConfiguracion = class(TForm)
    tab: TPageControl;
    tabCatalogo: TTabSheet;
    GroupBox2: TGroupBox;
    opObtenerDatosExtras: TCheckBox;
    GroupBox1: TGroupBox;
    lsExtensiones: TListBox;
    bNuevaExtension: TButton;
    bExcluirExtension: TButton;
    bCancelar: TButton;
    bGuardar: TButton;
    StaticText1: TStaticText;
    GroupBox3: TGroupBox;
    StaticText2: TStaticText;
    Label1: TLabel;
    txtCatalogarTamano: TEdit;
    GroupBox4: TGroupBox;
    Label2: TLabel;
    StaticText3: TStaticText;
    txtFiltro: TEdit;
    tabEmail: TTabSheet;
    Label3: TLabel;
    TabSheet1: TTabSheet;
    Label4: TLabel;
    GroupBox5: TGroupBox;
    opBDXML: TRadioButton;
    opBDAccess: TRadioButton;
    opBDParadox: TRadioButton;
    opBDFicheroTexto: TRadioButton;
    opBDMySQL: TRadioButton;
    pEMail: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label12: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    txtServidor: TEdit;
    txtUsuario: TEdit;
    txtEMailEmisor: TEdit;
    txtAsuntoEMail: TEdit;
    txtEMailDestinatario: TEdit;
    txtCC: TEdit;
    txtNombreEmisor: TEdit;
    txtPuerto: TEdit;
    txtTextoEmail: TMemo;
    opAutenticacion: TCheckBox;
    txtContrasena: TEdit;
    tabGuardarFicherosBD: TTabSheet;
    GroupBox6: TGroupBox;
    lsExtensionesGuardarContenido: TListBox;
    bNuevaExtensionContenido: TButton;
    bEliminarExtensionContenido: TButton;
    GroupBox7: TGroupBox;
    Label16: TLabel;
    StaticText5: TStaticText;
    Edit1: TEdit;
    GroupBox8: TGroupBox;
    Label17: TLabel;
    StaticText6: TStaticText;
    Edit2: TEdit;
    StaticText4: TStaticText;
    StaticText7: TStaticText;
    procedure bNuevaExtensionClick(Sender: TObject);
    procedure bExcluirExtensionClick(Sender: TObject);
    procedure bGuardarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure bEliminarExtensionContenidoClick(Sender: TObject);
    procedure bNuevaExtensionContenidoClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formConfiguracion: TformConfiguracion;

implementation

{$R *.dfm}

procedure TformConfiguracion.bNuevaExtensionClick(Sender: TObject);
var
  extension : string;
begin
  extension := InputBox('Introduzca la extensin a aadir:','Aadir extensin...','');
  if extension <> '' then
  begin
    lsExtensiones.Items.Add(extension);
  end;
end;

procedure TformConfiguracion.bExcluirExtensionClick(Sender: TObject);
begin
  lsExtensiones.DeleteSelected;
end;

procedure TformConfiguracion.bGuardarClick(Sender: TObject);
begin
  lsExtensiones.Items.SaveToFile(ExtractFilePath(Application.ExeName) + 'Extensiones.txt');
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    WriteBool ('Base de datos', 'XML', opBDXML.Checked);
    WriteBool ('Base de datos', 'Access', opBDAccess.Checked);
    WriteBool ('Base de datos', 'Paradox', opBDParadox.Checked);
    WriteBool ('Base de datos', 'MySQL', opBDMySQL.Checked);
    WriteBool ('Base de datos', 'Fichero', opBDFicheroTexto.Checked);

    WriteBool ('Opciones catalogacin', 'Datos extras', opObtenerDatosExtras.Checked);
    WriteFloat ('Opciones catalogacin', 'Tamao superior a', StrToFloat(txtCatalogarTamano.text));
    WriteString ('Opciones catalogacin', 'Filtro', txtFiltro.text);

    WriteString ('E-Mail', 'Usuario', txtUsuario.Text);
    WriteString ('E-Mail', 'Servidor', txtServidor.Text);
    WriteString ('E-Mail', 'E-Mail origen', txtEMailEmisor.Text);
    WriteString ('E-Mail', 'E-Mail destinatario', txtEMailDestinatario.Text);
    WriteString ('E-Mail', 'E-Mail CC', txtCC.Text);
    WriteString ('E-Mail', 'Asunto', txtAsuntoEMail.Text);
    WriteString ('E-Mail', 'Nombre emisor', txtNombreEmisor.Text);
    WriteBool ('E-Mail', 'Autenticacin', opAutenticacion.Checked);
    WriteString ('E-Mail', 'Contrasea', txtContrasena.Text);
    if txtPuerto.Text <> '' then
      WriteInteger ('E-Mail', 'Puerto', StrToInt(txtPuerto.Text));
    txtTextoEmail.Lines.SaveToFile (ExtractFilePath (ParamStr(0)) + '\TextoMensaje.txt');
  finally
    free;
  end;
  close;
end;

procedure TformConfiguracion.FormShow(Sender: TObject);
begin
  lsExtensiones.Items.LoadFromFile(ExtractFilePath(Application.ExeName) + 'Extensiones.txt');
  txtTextoEmail.Lines.LoadFromFile (ExtractFilePath (ParamStr(0)) + '\TextoMensaje.txt');
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    opBDXML.Checked := ReadBool ('Base de datos', 'XML', true);
    opBDAccess.Checked := ReadBool ('Base de datos', 'Access', false);
    opBDParadox.Checked := ReadBool ('Base de datos', 'Paradox', false);
    opBDMySQL.Checked := ReadBool ('Base de datos', 'MySQL', false);
    opBDFicheroTexto.Checked := ReadBool ('Base de datos', 'Fichero', false);

    opObtenerDatosExtras.Checked := ReadBool ('Opciones catalogacin', 'Datos extras', true);
    txtCatalogarTamano.text := floattostr(ReadFloat ('Opciones catalogacin', 'Tamao superior a', 0));
    txtFiltro.text := ReadString ('Opciones catalogacin', 'Filtro', '*.*');

    txtUsuario.Text := ReadString ('E-Mail', 'Usuario', '');
    txtServidor.Text := ReadString ('E-Mail', 'Servidor', '');
    txtEMailEmisor.Text := ReadString ('E-Mail', 'E-Mail origen', '');
    txtEMailDestinatario.Text := ReadString ('E-Mail', 'E-Mail destinatario', '');
    txtCC.Text := ReadString ('E-Mail', 'E-Mail CC', '');
    txtAsuntoEMail.Text := ReadString ('E-Mail', 'Asunto', '');
    txtNombreEmisor.Text := ReadString ('E-Mail', 'Nombre emisor', '');
    opAutenticacion.Checked := ReadBool ('E-Mail', 'Autenticacin', false);
    txtContrasena.Text := ReadString ('E-Mail', 'Contrasea', '');
    txtpuerto.Text := floattostr(ReadInteger ('E-Mail', 'Puerto', 25));
  finally
    free;
  end;
end;

procedure TformConfiguracion.bCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformConfiguracion.bEliminarExtensionContenidoClick(
  Sender: TObject);
begin
  lsExtensionesGuardarContenido.DeleteSelected;
end;

procedure TformConfiguracion.bNuevaExtensionContenidoClick(
  Sender: TObject);
var
  extension : string;
begin
  extension := InputBox('Introduzca la extensin a aadir:','Aadir extensin...','');
  if extension <> '' then
  begin
    lsExtensiones.Items.Add(extension);
  end;
end;

procedure TformConfiguracion.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

end.
