unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ActnList, Grids, DBGrids, DB, DBClient, StdCtrls,
  ExtCtrls, ToolWin, ComCtrls, ImgList, inifiles, DBCtrls, shellapi;

type
  TformMenuPrincipal = class(TForm)
    ActionList1: TActionList;
    MainMenu1: TMainMenu;
    actConfiguracion: TAction;
    actNuevoCatalogo: TAction;
    Archivo1: TMenuItem;
    Nuevocatlogo1: TMenuItem;
    db: TDataSource;
    tTabla: TClientDataSet;
    tTablaNombre: TStringField;
    tTablaDescripcion: TStringField;
    tTablaTamano: TFloatField;
    tTablaFechaCreacion: TDateField;
    actAbrirCatalogo: TAction;
    Configuracin1: TMenuItem;
    actSalir: TAction;
    N1: TMenuItem;
    Salir1: TMenuItem;
    Herramientas1: TMenuItem;
    Configuracin2: TMenuItem;
    Ayuda1: TMenuItem;
    be: TStatusBar;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    dlAbrir: TOpenDialog;
    Splitter1: TSplitter;
    PageControl1: TPageControl;
    tabCatalogos: TTabSheet;
    lCatalogos: TListBox;
    Panel1: TPanel;
    tabla: TDBGrid;
    tTablaUltimaModificacion: TDateTimeField;
    tTablaUltimoAcceso: TDateTimeField;
    tTablaAtributos: TStringField;
    tTablaTipoFichero: TStringField;
    tTablaNumeroSerie: TStringField;
    tTablaEtiqueta: TStringField;
    tTablaNivel: TIntegerField;
    tTablaCarpeta: TStringField;
    tTablaUnidad: TStringField;
    tTablaTipoUnidad: TStringField;
    actDatosFichero: TAction;
    tTablaVersionFichero: TStringField;
    tTablaExtension: TStringField;
    tTablaCompania: TStringField;
    tTablaNombreInterno: TStringField;
    tTablaDerechosCopia: TStringField;
    tTablaNombreOriginal: TStringField;
    tTablaNombreProducto: TStringField;
    tTablaVersionProducto: TStringField;
    tTablaComentarios: TStringField;
    tTablatipoFicheros: TStringField;
    tTablaLongitudFichero: TIntegerField;
    tTablasectoresPorCluster: TIntegerField;
    tTablabytesPorSector: TIntegerField;
    tTablanumeroClusterLibres: TIntegerField;
    tTablanumeroTotalCluster: TIntegerField;
    tTablaespacioLibreDisco: TFloatField;
    tTablaespacioOcupadoDisco: TFloatField;
    tTablaespacioTotalDisco: TFloatField;
    Panel2: TPanel;
    ToolBar2: TToolBar;
    DBNavigator1: TDBNavigator;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    actBuscar: TAction;
    ToolButton9: TToolButton;
    actAbrirFichero: TAction;
    ToolButton10: TToolButton;
    actAbrirCarpetaContenedora: TAction;
    ToolButton12: TToolButton;
    actAcercaDe: TAction;
    actEjecutarSQL: TAction;
    ToolButton11: TToolButton;
    Acercade1: TMenuItem;

    //para arrastrar y soltar
    procedure SoltarFichero  (var Msg: TWMDropFiles); message WM_DROPFILES;

    procedure actNuevoCatalogoExecute(Sender: TObject);
    procedure actSalirExecute(Sender: TObject);
    procedure actAbrirCatalogoExecute(Sender: TObject);
    procedure abrirCatalogo (fichero : string; nombreCatalogo : string);
    procedure insertarCatalogoLista (catalogo : TStrings; nombreCatalogo : string);
    procedure lCatalogosClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure actDatosFicheroExecute(Sender: TObject);
    procedure actConfiguracionExecute(Sender: TObject);
    procedure actBuscarExecute(Sender: TObject);
    procedure tTablaAfterApplyUpdates(Sender: TObject;
      var OwnerData: OleVariant);
    procedure tTablaAfterDelete(DataSet: TDataSet);
    procedure tTablaAfterInsert(DataSet: TDataSet);
    procedure actAbrirFicheroExecute(Sender: TObject);
    procedure actAbrirCarpetaContenedoraExecute(Sender: TObject);
    procedure tablaKeyPress(Sender: TObject; var Key: Char);
    procedure actAcercaDeExecute(Sender: TObject);
    procedure actEjecutarSQLExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

uses UnidadNuevoCatalogo, UnidadInformacionFichero, UnidadConfiguracion,
  UnidadBuscar, AcercaDe, UnidadConsultaSQL;

{$R *.dfm}


function existeCatalogo (listaCatalogos : TStrings; catalogo : string) : boolean;
var
  i : integer;
  existe : boolean;
begin
  existe := false;
  for i := 0 to listaCatalogos.Count - 1 do
  begin
    if listaCatalogos.Strings[i] = catalogo then
    begin
      existe := true;
      break;
    end;
  end;
  existeCatalogo := existe;
end;

function quitarExtension (fichero : string) : string;
begin
  quitarExtension := (copy (fichero, 1, pos (ExtractFileExt(fichero), fichero) - 1));
end;

procedure guardarEnINI (fichero : string; nombreCatalogo : string);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    writeString (nombreCatalogo, 'Ruta', fichero);
  finally
    free;
  end;
end;

function obtenerDeINI (nombreCatalogo : string) : string;
begin
  with tinifile.create (changefileext(paramstr(0), '.ini')) do
  try
    result := ReadString (nombreCatalogo, 'Ruta', '');
  finally
    free;
  end;
end;

procedure TformMenuPrincipal.insertarCatalogoLista (catalogo : TStrings; nombreCatalogo : string);
begin
  if existeCatalogo(catalogo, nombreCatalogo) then
    MessageDlg('El catlogo ' + nombreCatalogo +
       ' ya est abierto, para visualizarlo seleccinelo de la lista.',
       mtInformation, [mbok], 0)
  else
    lCatalogos.Items.Add(nombreCatalogo);
end;

procedure TformMenuPrincipal.abrirCatalogo (fichero : string; nombreCatalogo : string);
begin
  be.Panels[1].Text := 'Abriendo catlogo';
  Refresh;
  guardarEnIni (fichero, nombreCatalogo);
  tTabla.DisableControls;
  tTabla.Close;
  tTabla.FileName := fichero;
  try
    Screen.Cursor := crHourGlass;
    tTabla.Active := true;
    be.Panels[2].Text := inttostr(tTabla.RecordCount);
    tTabla.EnableControls;
    Screen.Cursor := crDefault;
    be.Panels[1].Text := nombreCatalogo;
  except
    Screen.Cursor := crDefault;
    MessageDlg('No se ha podido abrir el catlogo ' + fichero,
        mtWarning, [mbok], 0);
    be.Panels[2].Text := '';
    be.Panels[1].Text := 'Error al abrir catlogo';
  end;
end;

procedure TformMenuPrincipal.SoltarFichero (var Msg : TWMDropFiles);
var
  CFileName: array[0..MAX_PATH] of Char;
begin
  try
    if DragQueryFile(Msg.Drop, 0, CFileName, MAX_PATH) > 0 then
    begin
      if not existeCatalogo(lCatalogos.Items, quitarExtension(CFileName)) then
      begin
       insertarCatalogoLista (lCatalogos.Items, quitarExtension(ExtractFileName(CFileName)));
       abrirCatalogo(CFileName,  quitarExtension(ExtractFileName(CFileName)));
      end;
      Msg.Result := 0; 
    end;
  finally
    DragFinish(Msg.Drop); //finaliza arrastrar y soltar
  end;
end;


procedure TformMenuPrincipal.actNuevoCatalogoExecute(Sender: TObject);
var
  formulario : TformNuevoCatalogo;
begin
  tTabla.Active := false;
  formulario := TformNuevoCatalogo.Create(Application);
  try
    formulario.ShowModal;
  finally
    formulario.Free;
  end;
end;

procedure TformMenuPrincipal.actSalirExecute(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.actAbrirCatalogoExecute(Sender: TObject);
var
  nombreCatalogo, nombreFichero : string;
begin
  dlabrir.Filter := 'Catlogos (*.xml)|*.xml|Todos los archivos (*.*)|*.*';
  dlAbrir.InitialDir := ExtractFilePath(Application.ExeName);
  dlAbrir.Title := 'Seleccione el catlogo a abrir...';
  if dlAbrir.Execute then
  begin
    nombreFichero := dlAbrir.FileName;
    nombreCatalogo := quitarExtension(ExtractFileName(nombreFichero));
    if not existeCatalogo(lCatalogos.Items, nombreCatalogo) then
    begin
      insertarCatalogoLista (lCatalogos.Items, nombreCatalogo);
      abrirCatalogo(nombreFichero, nombreCatalogo);
    end;
  end;
end;

procedure TformMenuPrincipal.lCatalogosClick(Sender: TObject);
begin
  if lCatalogos.ItemIndex <> -1 then
  begin
    abrirCatalogo(obtenerDeINI(lCatalogos.Items[lCatalogos.ItemIndex]), lCatalogos.Items[lCatalogos.ItemIndex]);
  end;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  //permitimos arrastrar y soltar
   DragAcceptFiles(Handle, True);
   
   //si se ha abierto con algn catlogo como parmetro
   if (ParamCount > 0) and FileExists(ParamStr(1)) then
   begin
     insertarCatalogoLista (lCatalogos.Items, quitarExtension(ParamStr(1)));
     abrirCatalogo (ParamStr(1), quitarExtension(ParamStr(1)));
   end;
end;

procedure TformMenuPrincipal.actDatosFicheroExecute(Sender: TObject);
var
  formulario : TformInformacionFichero;
begin
  if tTabla.Active then
  begin
    if tTabla.RecordCount > 0 then
    begin
      formulario := TformInformacionFichero.Create(Application);
      try
        formulario.ShowModal;
      finally
        formulario.Free;
      end;
    end
    else
      MessageDlg('No hay datos en este catlogo.', mtInformation, [mbok], 0);
  end
  else
    MessageDlg('No hay catlogos abiertos.', mtInformation, [mbok], 0);
end;

procedure TformMenuPrincipal.actConfiguracionExecute(Sender: TObject);
var
  formulario : Tformconfiguracion;
begin
  formulario := Tformconfiguracion.Create(Application);
  try
    formulario.ShowModal;
  finally
    formulario.Free;
  end;
end;

procedure TformMenuPrincipal.actBuscarExecute(Sender: TObject);
var
  formulario : TformBuscar;
begin
  if tTabla.Active then
  begin
    if tTabla.RecordCount > 0 then
    begin
      formulario := TformBuscar.Create(Application);
      try
        formulario.ShowModal;
      finally
        formulario.Free;
      end;
    end
    else
      MessageDlg('No hay datos en este catlogo.', mtInformation, [mbok], 0);
  end
  else
    MessageDlg('No hay catlogos abiertos.', mtInformation, [mbok], 0);
end;

procedure TformMenuPrincipal.tTablaAfterApplyUpdates(Sender: TObject;
  var OwnerData: OleVariant);
begin
  if tTabla.Active then
    be.Panels[2].Text := inttostr(tTabla.RecordCount);
end;

procedure TformMenuPrincipal.tTablaAfterDelete(DataSet: TDataSet);
begin
  if tTabla.Active then
    be.Panels[2].Text := inttostr(tTabla.RecordCount);
end;

procedure TformMenuPrincipal.tTablaAfterInsert(DataSet: TDataSet);
begin
  if tTabla.Active then
    be.Panels[2].Text := inttostr(tTabla.RecordCount);
end;

procedure TformMenuPrincipal.actAbrirFicheroExecute(Sender: TObject);
var
  fichero, carpeta : string;
  resultado : THandle;
begin
  if not varisnull(tTabla.fieldbyname('Nombre').value) then
    fichero := tTabla.fieldbyname('Nombre').value
  else
    fichero := '';
  if not varisnull(tTabla.fieldbyname('Carpeta').value) then
    carpeta := tTabla.fieldbyname('Carpeta').value
  else
    carpeta := '';
  if (carpeta <> '') and (fichero <> '') then
  begin
    //aadimos / si no la lleva
    if carpeta[Length(carpeta)] <> '\' then
      carpeta := carpeta + '\';
    if FileExists(carpeta + fichero) then
    begin
      resultado := ShellExecute(Handle, Nil, PChar(carpeta + fichero), Nil, Nil, SW_SHOWNORMAL);
      if resultado = 0 then
        MessageDlg('No se ha podido ejecutar el fichero: ' + chr(13) + chr(13) +
          carpeta + fichero + chr(13) + chr(13) + ' en este equipo.',
          mtInformation, [mbok], 0);
    end
    else
      MessageDlg('No se ha encontrado el fichero: ' + chr(13) + chr(13) +
          carpeta + fichero + chr(13) + chr(13) + ' en este equipo.',
          mtInformation, [mbok], 0);
  end
  else
    MessageDlg('No se ha ejecutado el fichero actual porque faltan datos.',
        mtInformation, [mbok], 0);
end;

procedure TformMenuPrincipal.actAbrirCarpetaContenedoraExecute(
  Sender: TObject);
var
  carpeta : string;
  resultado : THandle;
begin
  if not varisnull(tTabla.fieldbyname('Carpeta').value) then
    carpeta := tTabla.fieldbyname('Carpeta').value
  else
    carpeta := '';
  if (carpeta <> '') then
  begin
    if DirectoryExists(carpeta) then
    begin
      resultado := ShellExecute(Handle, Nil, PChar(carpeta), Nil, Nil, SW_SHOWNORMAL);
      if resultado = 0 then
        MessageDlg('No se ha podido abrir la carpeta: ' + chr(13) + chr(13) +
          carpeta + chr(13) + chr(13) + ' en este equipo.',
          mtInformation, [mbok], 0);
    end
    else
      MessageDlg('No se ha encontrado la carpeta: ' + chr(13) + chr(13) +
          carpeta + chr(13) + chr(13) + ' en este equipo.',
          mtInformation, [mbok], 0);
  end
  else
    MessageDlg('No se ha abierto la carpeta actual porque faltan datos.',
        mtInformation, [mbok], 0);
end;

procedure TformMenuPrincipal.tablaKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
    actDatosFicheroExecute(nil);
end;

procedure TformMenuPrincipal.actAcercaDeExecute(Sender: TObject);
var
  formulario : TformAcercaDe;
begin
  formulario := TformAcercaDe.Create(Application);
  try
    formulario.ShowModal;
  finally
    formulario.Free;
  end;
end;

procedure TformMenuPrincipal.actEjecutarSQLExecute(Sender: TObject);
var
  formulario : TformEjecutarSQL;
begin
  if tTabla.Active then
  begin
    if tTabla.RecordCount > 0 then
    begin
      formulario := TformEjecutarSQL.Create(Application);
      try
        formulario.ShowModal;
      finally
        formulario.Free;
      end;
    end
    else
      MessageDlg('No hay datos en este catlogo.', mtInformation, [mbok], 0);
  end
  else
    MessageDlg('No hay catlogos abiertos.', mtInformation, [mbok], 0);
end;

end.
