unit UnidadNuevoCatalogo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, DB, DBClient, ComCtrls, ShellCtrls, ShlObj, activex,
  Buttons;
  //Grids, DirOutln, Buttons, ExtCtrls,DBTables,   ToolWin;

type
  TformNuevoCatalogo = class(TForm)
    GroupBox1: TGroupBox;
    bCarpetaRed: TButton;
    txtRed: TEdit;
    dC: TDataSource;
    tc: TClientDataSet;
    be: TStatusBar;
    GroupBox2: TGroupBox;
    txtNombreCatalogo: TEdit;
    opExisteCatalogo: TCheckBox;
    bp: TProgressBar;
    bCatalogar: TBitBtn;
    bCancelar: TBitBtn;
    bInfoDisco: TBitBtn;
    bOpciones: TBitBtn;
    bCerrar: TBitBtn;
    procedure bCatalogarClick(Sender: TObject);
    procedure crearCatalogo (fichero : string);
    function SeleccionarCarpeta () : string;
    procedure insertarFichero (fichero, filtro, carpeta : string; Recursiva : boolean);
    procedure obtenerSubcarpetas (carpeta : string; sLista : TStringList);
    procedure bCarpetaRedClick(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure bInfoDiscoClick(Sender: TObject);
    procedure bOpcionesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bCerrarClick(Sender: TObject);
  private
    { Private declarations }
    numero : integer;
  public
    { Public declarations }
  end;

var
  formNuevoCatalogo: TformNuevoCatalogo;

  etiqueta, tipoFicheros, numeroSerie : string;
  longitudMaximaFichero : DWORD;
  sectoresPorCluster : DWORD;
  bytesPorSector : DWORD;
  numeroClusterLibres : DWORD;
  numeroTotalCluster : DWORD;
  espacioLibreDisco : double;
  espacioOcupadoDisco : double;
  espacioTotalDisco : double;

  infoUnidad : boolean;  //para ejecutar la funcin de obtener info unidad una sola vez
  espacioActual : Double; //para mostrar progreso
  cancelarProceso : boolean;

implementation

uses UnidadMenuPrincipal, UnidadInformacionDisco, UnidadConfiguracion;

{$R *.dfm}

procedure obtenerDatosUnidad (unidad : string);
var
  VolumeName : array [0..255] of Char;
  FileSystemType : array [0..255] of Char;
  SerialNum : DWORD;
  MaxFilenameLength : DWORD;
  Flags : DWORD;
  vNumeroClusterLibres, vbytesPorSector, vsectoresPorCluster, vnumeroTotalCluster : Double;
begin
  //etiqueta, nmero serie, sistema archivos, longitud mxima fichero
  if (GetVolumeInformation(PChar(unidad), VolumeName,  256,  @SerialNum,
      MaxFilenameLength, Flags, FileSystemType, 256))then
  begin
    etiqueta := VolumeName;
    tipoFicheros := FileSystemType;
    numeroSerie := IntToHex(HiWord(SerialNum), 4) + ' - ' +
        IntToHex(LoWord(SerialNum), 4) ;
    LongitudMaximaFichero := MaxFilenameLength;
  end
  else
  begin
    etiqueta := '';
    tipoFicheros := '';
    LongitudMaximaFichero := 0;
  end;

  //sectores, cluster, ...
  if Windows.GetDiskFreeSpace(pchar(unidad), sectoresPorCluster, bytesPorSector,
      numeroClusterLibres, numeroTotalCluster) then
  begin
    vNumeroClusterLibres := numeroClusterLibres;
    vbytesPorSector := bytesPorSector;
    vsectoresPorCluster := sectoresPorCluster;
    vnumeroTotalCluster := numeroTotalCluster;
    espacioLibreDisco := vNumeroClusterLibres * vbytesPorSector * vsectoresPorCluster;
    espacioTotalDisco := vnumeroTotalCluster * vbytesPorSector * vsectoresPorCluster;
    espacioOcupadoDisco := espacioTotalDisco - espacioLibreDisco;
  end
  else
  begin
    espacioLibreDisco := 0;
    espacioTotalDisco := 0;
    espacioOcupadoDisco := 0;
    sectoresPorCluster := 0;
    bytesPorSector := 0;
    numeroClusterLibres := 0;
    numeroTotalCluster := 0;
  end;
end;


//Obtiene la versin del fichero - NO LA UTILIZO
{function versionFichero (const FileName: TFileName; var Major, Minor, Release, Build : word): boolean;
var
  size, len: longword;
  handle: THandle;
  buffer: pchar;
  pinfo: ^VS_FIXEDFILEINFO;
begin
  Result := False;
  size := GetFileVersionInfoSize(Pointer(FileName), handle);
  if size > 0 then begin
    GetMem(buffer, size);
    if GetFileVersionInfo(Pointer(FileName), 0, size, buffer)
    then
      if VerQueryValue(buffer, '\', pointer(pinfo), len) then begin
        Major   := HiWord(pinfo.dwFileVersionMS);
        Minor   := LoWord(pinfo.dwFileVersionMS);
        Release := HiWord(pinfo.dwFileVersionLS);
        Build   := LoWord(pinfo.dwFileVersionLS);
        Result  := True;
      end;
    FreeMem(buffer);
  end;
end;}

//Obtiene el dato pasado como parmetro del fichero especificado
function obtenerInfoFichero (info : string; fichero : string) : string;
type
  PaLeerBuffer = array [0..MAX_PATH] of char;
var
  Size, Size2 : DWord;
  Pt, Pt2 : Pointer;
  Idioma : string;
begin
  Result := '';
  try
    Size := GetFileVersionInfoSize(PChar (fichero), Size2);
    if Size > 0 then
    begin
      GetMem (Pt, Size);
      if GetFileVersionInfo (PChar (fichero), 0, Size, Pt) then
      begin
        VerQueryValue(Pt, '\VarFileInfo\Translation',Pt2, Size2);
        if Size2 > 0 then
        begin
          Idioma := IntToHex(DWord(Pt2^) , 8);
          Idioma := Copy(Idioma, 5, 4) + Copy(Idioma, 1, 4);
          VerQueryValue( Pt,Pchar('\StringFileInfo\'+Idioma+'\'+info),Pt2, Size2);
          if Size2 > 0 then
          begin
           Result := Copy(PaLeerBuffer(Pt2^),1,Size2);
          end;
        end
        else
          result := '';
        FreeMem (Pt);
      end
      else
        Result := '';
    end
    else
      result := '';
  except
    //silenciosa
  end;
end;

//obtiene el tamao de un fichero - debe estar cerrado
function tamanoFichero (fichero : string) : Longint;
var
  f : file of Byte;
  size : Longint;
begin
  AssignFile(f, fichero);
  try
    Reset(f);
    try
      size := FileSize(f);
      Result := size;
    finally
      CloseFile (f);
    end;
  except
    Result := 0;
    exit;
  end;
end;


//obtiene la fecha de creacin de un fichero
function extracerFechaCreacionFichero (nombreFichero : string): string;
var
  FHandle: integer;
begin
  FHandle := FileOpen(nombreFichero, 0);
  try
    Result := DateTimeToStr(FileDateToDateTime(FileGetDate(FHandle)));
  finally
    FileClose(FHandle);
  end;
end;

{procedure extraerInfoFichero (Instance : THandle; ResID : Integer; ResType, FileName : String);
var
  ResStream: TResourceStream;
  FileStream: TFileStream;
begin
  try
    ResStream := TResourceStream.CreateFromID(Instance, ResID, pChar(ResType));
    try
      //if FileExists(FileName) then
        //DeleteFile(pChar(FileName));
      FileStream := TFileStream.Create(FileName, fmCreate);
      try
        FileStream.CopyFrom(ResStream, 0);
      finally
        FileStream.Free;
      end;
    finally
      ResStream.Free;
    end;
  except
    on E:Exception do
    begin
      DeleteFile(FileName);
      raise;
    end;
  end;
end;}

procedure TformNuevoCatalogo.crearCatalogo (fichero : string);
begin
  tc.Close;
  tc.FieldDefs.Clear;
  tc.FieldDefs.Add ('Nivel', ftInteger);
  tc.FieldDefs.Add ('Carpeta', ftString, 255);
  tc.FieldDefs.Add ('Nombre', ftString, 255);
  tc.FieldDefs.Add ('VersionFichero', ftString, 20);
  tc.FieldDefs.Add ('Descripcion', ftString, 500);
  tc.FieldDefs.Add ('Tamano', ftFloat, 0);
  tc.FieldDefs.Add ('FechaCreacion', ftDateTime, 0);
  tc.FieldDefs.Add ('UltimaModificacion', ftDateTime, 0);
  tc.FieldDefs.Add ('UltimoAcceso', ftDateTime, 0);
  tc.FieldDefs.Add ('Atributos', ftString, 6);
  tc.FieldDefs.Add ('TipoFichero', ftString, 30);
  tc.FieldDefs.Add ('Contenido', ftMemo);

  tc.FieldDefs.Add ('Unidad', ftString, 30);
  tc.FieldDefs.Add ('NumeroSerie', ftString, 100);
  tc.FieldDefs.Add ('Etiqueta', ftString, 50);
  tc.FieldDefs.Add ('TipoUnidad', ftString, 30);
  tc.FieldDefs.Add ('tipoFicheros', ftString, 30);
  tc.FieldDefs.Add ('LongitudFichero', ftInteger);
  tc.FieldDefs.Add ('sectoresPorCluster', ftInteger);
  tc.FieldDefs.Add ('bytesPorSector', ftInteger);
  tc.FieldDefs.Add ('numeroClusterLibres', ftInteger);
  tc.FieldDefs.Add ('numeroTotalCluster', ftInteger);
  tc.FieldDefs.Add ('espacioLibreDisco', ftFloat);
  tc.FieldDefs.Add ('espacioOcupadoDisco', ftFloat);
  tc.FieldDefs.Add ('espacioTotalDisco', ftFloat);

  tc.FieldDefs.Add ('Extension', ftString, 10);
  tc.FieldDefs.Add ('Compania', ftString, 100);
  tc.FieldDefs.Add ('NombreInterno', ftString, 255);
  tc.FieldDefs.Add ('DerechosCopia', ftString, 100);
  tc.FieldDefs.Add ('NombreOriginal', ftString, 100);
  tc.FieldDefs.Add ('NombreProducto', ftString, 100);
  tc.FieldDefs.Add ('VersionProducto', ftString, 50);
  tc.FieldDefs.Add ('Comentarios', ftString, 255);
  tc.CreateDataSet;
  tc.SaveToFile(fichero, dfXMLUTF8);
end;


function TformNuevoCatalogo.SeleccionarCarpeta () : string;
var
  Inf: TBrowseInfo;
  Identificador: PItemIDList;
  Gestor : IMalloc;
  Carpeta : Array[0..MAX_PATH] Of Char;
begin
  With Inf Do
  Begin
    hwndOwner := Handle;
    pidlRoot := Nil;
    pszDisplayName := Carpeta;
    lpszTitle := 'Seleccione ubicacin a catalogar...';
    ulFlags := BIF_BROWSEINCLUDEFILES;
    lpfn := Nil;
  End;
  Identificador := SHBrowseForFolder(Inf);
  If Identificador <> Nil Then
  Begin
    SHGetPathFromIDList(Identificador, Carpeta);
    SHGetMalloc(Gestor);
    Gestor.Free(Identificador);
    SeleccionarCarpeta := Carpeta
  end;
end;

procedure TformNuevoCatalogo.insertarFichero (fichero, filtro, carpeta : string; Recursiva : boolean);
var
  sr : TSearchRec;
  sListaCarpetas : TStringList;
  i : integer;
  unidad, extensionFichero : string;
  sizeFichero : Longint;
  posicionProgreso : Double;
begin
  if FindFirst(carpeta + filtro, faAnyFile, sr) = 0 then
  begin
    repeat
      if cancelarProceso then
      begin
        FindClose(sr);
        Exit;
      end;
      numero := numero + 1;
      be.Panels[0].Text := 'Catalogando ' + carpeta + sr.Name;
      be.Panels[1].Text := inttostr(numero);
      be.Refresh;
      unidad := ExtractFileDrive(carpeta);
      if not infoUnidad then
      begin
        obtenerDatosUnidad(unidad);
        infoUnidad := true;
      end;

      tc.Insert;
      //datos de la unidad
      tc.FieldByName('Unidad').Value := unidad;
      tc.FieldByName('NumeroSerie').Value := numeroSerie;
      tc.FieldByName('tipoFicheros').Value := tipoFicheros;
      tc.FieldByName('LongitudFichero').Value := longitudMaximaFichero;
      tc.FieldByName('sectoresPorCluster').Value := sectoresPorCluster;
      tc.FieldByName('bytesPorSector').Value := bytesPorSector;
      tc.FieldByName('numeroClusterLibres').Value := numeroClusterLibres;
      tc.FieldByName('numeroTotalCluster').Value := numeroTotalCluster;
      tc.FieldByName('espacioLibreDisco').Value := espacioLibreDisco;
      tc.FieldByName('espacioOcupadoDisco').Value := espacioOcupadoDisco;
      tc.FieldByName('espacioTotalDisco').Value := espacioTotalDisco;

      tc.FieldByName('Carpeta').Value := carpeta;
      //tc.FieldByName('Nivel').Value := sr.Time;

      //si es un fichero
      if (sr.Name <> '') and (sr.Name <> '.') and (sr.Name <> '..') then
      begin
        //datos del fichero
        extensionFichero := ExtractFileExt(sr.Name);
        //quitamos el . a la extensin
        if extensionFichero <> '' then
          if extensionFichero[1] = '.' then
            extensionFichero := copy (extensionFichero, 2, length(extensionFichero));
        tc.FieldByName('Nombre').Value := sr.name;
        tc.FieldByName('Extension').Value := extensionFichero;
        //tc.FieldByName('FechaCreacion').Value :=  extracerFechaCreacionFichero (carpeta + sr.Name);
        sizeFichero := tamanoFichero(carpeta + sr.Name);
        tc.FieldByName('Tamano').Value := sizeFichero;
        //datos extras del fichero
        tc.FieldByName('Compania').Value := obtenerInfoFichero ('CompanyName', carpeta + sr.Name);
        tc.FieldByName('Descripcion').Value := obtenerInfoFichero ('FileDescription', carpeta + sr.Name);
        tc.FieldByName('NombreInterno').Value := obtenerInfoFichero ('InternalName', carpeta + sr.Name);
        tc.FieldByName('DerechosCopia').Value := obtenerInfoFichero ('LegalCopyright', carpeta + sr.Name);
        tc.FieldByName('NombreOriginal').Value := obtenerInfoFichero ('OriginalFilename', carpeta + sr.Name);
        tc.FieldByName('NombreProducto').Value := obtenerInfoFichero ('ProductName', carpeta + sr.Name);
        tc.FieldByName('VersionProducto').Value := obtenerInfoFichero ('ProductVersion', carpeta + sr.Name);
        tc.FieldByName('VersionFichero').Value := obtenerInfoFichero ('FileVersion', carpeta + sr.Name);
        tc.FieldByName('Comentarios').Value := obtenerInfoFichero ('Comments', carpeta + sr.Name);
      end;
      tc.Post;
      try
        espacioActual := sizeFichero + espacioActual;
        posicionProgreso := (espacioActual * 100) / espacioOcupadoDisco;
        bp.Position :=  StrToInt(FloatToStr(int (posicionProgreso)));
        bp.Refresh;
      except
        //silenciosa
      end;
    until FindNext(sr) <> 0;
  end;
  FindClose(sr);

  if Recursiva then
  begin
    sListaCarpetas := TStringList.Create;
    try
      obtenerSubcarpetas (carpeta, sListaCarpetas);
      for i := 0 to sListaCarpetas.Count - 1 do
      begin
        if (sListaCarpetas[i] <> '.') and (sListaCarpetas[i] <> '..') then
        begin
          Application.ProcessMessages;
          insertarFichero (fichero, filtro, IncludeTrailingPathDelimiter(carpeta +
              sListaCarpetas[i]), Recursiva);
        end;
      end;
    finally
      sListaCarpetas.Free;
    end;
  end;
end;

procedure TformNuevoCatalogo.obtenerSubcarpetas (carpeta : string; sLista : TStringList);
 var
  sr : TSearchRec;
begin
  if FindFirst(carpeta + '*.*', faDirectory, sr) = 0 then
   try
    repeat
      if(sr.Attr and faDirectory) = faDirectory then
       sLista.Add(sr.Name);
    until FindNext(sr) <> 0;
   finally
     FindClose(sr);
   end;
end;


procedure TformNuevoCatalogo.bCatalogarClick(Sender: TObject);
var
  rutaCatalogo : string;
  seguir : boolean;
  rutaRed : string;
begin
  cancelarProceso := false;
  bCancelar.Enabled := true;
  infoUnidad := false;
  espacioActual := 0;
  bp.Min := 0;
  bp.Max := 100;
  bp.Visible := true;
  if (txtNombreCatalogo.Text <> '') and (txtRed.Text <> '') then
  begin
    rutaCatalogo := ExtractFilePath(Application.ExeName) + txtNombreCatalogo.Text + '.xml';
    seguir := true;
    if FileExists(rutaCatalogo) then
    begin
      if opExisteCatalogo.Checked then
        seguir := true
      else
      begin
        if MessageDlg('El catlogo ' + txtNombreCatalogo.Text + ' ya existe desea reemplazarlo?',
            mtConfirmation, [mbyes,mbno], 0) = mryes then
        begin
          DeleteFile(rutaCatalogo);
          seguir := true;
        end
        else
          seguir := false;
      end;
    end;
    if seguir then
    begin
      if (not FileExists(rutaCatalogo)) then
      begin
        be.Panels[0].Text := 'Creando catlogo';
        be.Refresh;
        crearCatalogo(rutaCatalogo);
      end;
      tc.Close;
      tc.FileName := rutaCatalogo;
      tc.Open;
      numero := 0;
      rutaRed := txtRed.Text;
      if rutaRed[Length(rutaRed)] <> '\' then
        rutaRed := rutaRed + '\';
      insertarFichero (rutaCatalogo, '*.*', rutaRed, true);
      tc.Close;
      be.Panels[0].Text := 'El proceso ha finalizado correctamente';
      be.Refresh;
      if MessageDlg('El catlogo ' + txtNombreCatalogo.Text +
          ' ha sido actualizado correctamente. Desea crear otro catlogo?',
          mtConfirmation, [mbyes,mbno], 0) = mryes then
      begin
        txtNombreCatalogo.Text := '';
        txtRed.Text := '';
        bCarpetaRed.SetFocus;
        be.Panels[0].Text := '';
        be.Panels[1].Text := '';
      end
      else
        close;
    end;
  end
  else
  begin
    MessageDlg('Debe especificar el nombre del catlogo y la unidad/ruta a catalogar.', mtInformation, [mbok], 0);
    bCarpetaRed.SetFocus;
  end;
  bp.Visible := false;
end;

procedure TformNuevoCatalogo.bCarpetaRedClick(Sender: TObject);
var
  unidad, seleccion : string;
begin
  seleccion := SeleccionarCarpeta;
  if seleccion <> '' then
  begin
    txtRed.Text := seleccion;
    unidad := ExtractFileDrive(seleccion);
    obtenerDatosUnidad(unidad);
    //if txtNombreCatalogo.Text = '' then
      txtNombreCatalogo.Text := unidad[1] + ' - ' + etiqueta;
  end;
end;

procedure TformNuevoCatalogo.bCancelarClick(Sender: TObject);
begin
  cancelarProceso := true;
  bCancelar.Enabled := false;
  txtRed.SetFocus;
  be.Panels[0].Text := 'Proceso cancelado';
  be.Panels[1].Text := '';               
end;

procedure TformNuevoCatalogo.bInfoDiscoClick(Sender: TObject);
var
  formulario : TformInformacionDisco;
  unidad : string;
begin
  unidad := ExtractFileDrive(txtRed.Text);
  obtenerDatosUnidad(unidad);
  formulario := TformInformacionDisco.Create(Application);
  try
  formulario.mInfo.Clear;
  formulario.lInfo.Caption := 'Informacin del disco ' + unidad;
  formulario.mInfo.Lines.Add ('Unidad: ' + unidad);
  formulario.mInfo.Lines.Add ('Etiqueta: ' + etiqueta);
  formulario.mInfo.Lines.Add ('N de serie: ' + numeroSerie);
  formulario.mInfo.Lines.Add ('Sistema de archivo: ' + tipoFicheros);
  formulario.mInfo.Lines.Add ('Longitud mxima nombre fichero: ' + IntToStr(longitudMaximaFichero));
  formulario.mInfo.Lines.Add ('Sectores por cluster: ' + FormatFloat('#,###', sectoresPorCluster));
  formulario.mInfo.Lines.Add ('Bytes por sector: ' + FormatFloat('#,###', bytesPorSector));
  formulario.mInfo.Lines.Add ('N total de cluster: ' + FormatFloat('#,###', numeroTotalCluster));
  formulario.mInfo.Lines.Add ('N de cluster libres: ' + FormatFloat('#,###', numeroClusterLibres));
  formulario.mInfo.Lines.Add ('Espacio total de disco: ' +  FormatFloat('#,###" Bytes"', espacioTotalDisco));
  formulario.mInfo.Lines.Add ('Espacio ocupado en disco: ' + FormatFloat('#,###" Bytes"', espacioOcupadoDisco));
  formulario.mInfo.Lines.Add ('Espacio libre en disco: ' + FormatFloat('#,###" Bytes"', espacioLibreDisco));
  formulario.ShowModal;
  finally
    formulario.Free;
  end;
end;

procedure TformNuevoCatalogo.bOpcionesClick(Sender: TObject);
var
  formulario : Tformconfiguracion;
begin
  formulario := Tformconfiguracion.Create(Application);
  try
    formulario.ShowModal;
  finally
    formulario.Free;
  end;
end;


procedure TformNuevoCatalogo.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  tc.Close;
  Action := caFree;
end;

procedure TformNuevoCatalogo.bCerrarClick(Sender: TObject);
begin
  bCancelarClick(nil);
  close;
end;

end.
